## crm114 20090423

=== Makefile ===
#
#    Makefile for CRM114
#
# Copyright 2009 William S. Yerazunis.
# This file is under GPLv3, as described in COPYING.

#   If you want to install the executables somewhere else, change
#    BINDIR here.  Default is /usr/bin but you can change it to /usr/local/bin
#     if you prefer that sort of thing.
#
prefix?=/usr
BINDIR=${prefix}/bin

# VER_SUFFIX defines a version suffix for our installed executables,
# handy when you want many versions of CRM114 coexisting.
#
# e.g.: VER_SUFFIX=27B-6, then if you make install, you get crm-27b-6
#
VER_SUFFIX ?=

#
#      The following forces the compiler to be GCC.  If you have trouble
#      with your default compiler, and you want to force GCC, uncomment it.
# CC=gcc
#
#     What version is this software (PLEASE don't change this just
#     to mess with my brain. - wsy)
#
CRM114_ARCHIVE = /homes/crm114/archive
VERSION=200904023-BlameSteveJobs
PREV_VERSION=20090120-BlameSteveJobs
#PREV_VERSION=20081111-BlameBarack
#PREV_VERSION=20081023-BlameMaxwell
#PREV_VERSION=20080923-BlameVT
#PREV_VERSION=20080618-BlameBadGlasses
#PREV_VERSION=20080502-BlameJason
#PREV_VERSION=20080326-BlameSentansoken
#PREV_VERSION=20080217-BlameJoeLangeway_VT
#PREV_VERSION=20071201-BlameLittleStevie_VT
#PREV_VERSION=20071126-BlameGerHobbelt
#PREV_VERSION=20070917-BlameGerHobbelt
#VERSION=20070830-BlameGerHobbelt
#PREV_VERSION=20070828-BlameGerHobbelt
#PREV_VERSION=20070827-BlameGerHobbelt
#PREV_VERSION=20070826-BlameGerHobbelt
#PREV_VERSION = 20070815-BlameBadData
#PREV_VERSION = 20070810-BlameTheSegfault
#PREV_VERSION = 20070505-BlameIdiocy
#PREV_VERSION = 20061103-BlameDalkey
#PREV_VERSION = 20061010-BlameBratko
#PREV_VERSION = 20060920-BlameNico
#PREV_VERSION = 20060704a-BlameRobert
#PREV_VERSION = 20060619-MargarineBeast
#PREV_VERSION = 20060611-ButterBeast
#PREV_VERSION = 20060611-SomewhatTamedBeast
#PREV_VERSION = 20060606-VersionOfTheBeast
#PREV_VERSION = 20060429-ReaverReturn
#PREV_VERSION = 20060118-BlameTheReavers
#PREV_VERSION = 20051231a-BlameBarryAndPaolo
#PREV_VERSION = 20051001-BlameRaulMiller
#PREV_VERSION = crm114-20050721-BlameNeilArmstrong
#
#   Define the TRE directory (used only for building distributions- note that
#   this must be HAND-UPDATED when new versions of TRE come out  )
TRE_TARFILE = tre-0.7.5
# VERSION += [$(TRE_TARFILE)]
#
#
#      Are we compiling on a POSIX system or a Windows system?  NOTE:
#       WINDOWS IS UNSUPPORTED BY THE AUTHOR.  THE AUTHOR WILL
#	ACCEPT REASONABLE-LOOKING PATCHES BUT WINDOWS-ONLY
#       BUG REPORTS THAT DO NOT REPRODUCE UNDER LINUX ET AL
#       SIMPLY _CANNOT_ BE WORKED AS I HAVE NO WINDOWS MACHINES.
#       SO, IF YOU FIND A WINDOWS-ONLY BUG, PLEASE PUT IT ON THE
#       MAILING LIST SO WINDOWS PEOPLE CAN WORK THE BUG.
#
# CFLAGS += -DWIN32
#
#     Build our basic CFLAGS chunk
#
CFLAGS += -DVERSION='"$(VERSION)"'
#
#  Known Neighbord On, only for debugging
# CFLAGS += -DKNN_ON
#
#  Ben Graphic, only for debugging
# CFLAGS += -DBEN_GRAPHIC
#
#  Stab test, long accepted
# CFLAGS += -DSTAB_TEST
#
#  Stochastic setting, unused in crm_neural_net.c
# CFLAGS += -DSTOCHASTIC
#
#  Tell the compiler full optimization "-O3", add debugging info "-g",
#  and warn on all warnable things "-Wall".  Someday add -Wextra for
#  really picayune stuff.
#
#  Our default is with debugging, full optimization, and lots of warnings:
CFLAGS += -g -O3 -Wall
#     turn this one on for no optimization, but debugging
#CFLAGS += -g -O0 -Wall
#
#     Turn this one on for time profiling.
#CFLAGS += -pg
#     turn this one on for really picayune debugging:
# CFLAGS += -Wextra
#
#   Choose between static and dynamic linking (we recommend static linking)
#   Comment this out if you want dynamic linking
#
#    BSD users - do NOT use -static-libgcc!!!
LDFLAGS += -static -static-libgcc
#    use this one if you want program profiling.
#LDFLAGS += -static -static-libgcc -pg
#LDFLAGS += -pg
#
#   Any standard install flags?  We nominally use protection 755
INSTALLFLAGS += -m 755
#
#        uncomment the next line if you want to "strip" the debugger info
#        from the binaries when installing.  This speeds up load, but
#        you won't be able to submit meaningful CRM114 engine bug reports.
#        Default is don't strip.
# INSTALLFLAGS += -s
#
#
#        Libraries to link against.
LIBS += -lm
#
# ---------   If you're compiling under *BSD, check these out:
#
#    Simson Garfinkel suggests that you
#    uncomment the following to get a BSD-sane environment.  Leave them
#    untouched (commented out) for Linux builds.
# Add for FreeBSD:
#CFLAGS += -I/usr/local/include
#LDFLAGS += -L/usr/local/lib
#LIBS += -lintl -liconv
#LDFLAGS += -dynamic-libgcc
#
#    Jeff Rice suggests the following for FreeBSD:
#CFLAGS += -I/usr/local/include -I${HOME}/include
#LDFLAGS += -L/usr/local/lib -L${HOME}/lib
#LIBS += -lintl -liconv
#
#    Nico Kadel-Garcia has added these flags for systems without logl or sqrtf
#  BSD has no logl function
# CFLAGS += -DNO_LOGL
#
#  BSD has no sqrtf function
# CFLAGS += -DNO_SQRTF
# ------------------ end of *BSD stuff
#
# ------------------For Mac OSX, try this---------------
#
#    Yimin Wu (of the SVMx classifiers) suggests that to get
#    a good compile on the Mac OSX machines, try:
#
#   COMMENT OUT all the above "LDFLAGS += -static -static-libgcc -pg"
#
#    and add
#
#CFLAGS += -I/usr/local/include
#LDFLAGS += -l/usr/local/lib
#
#  and change final options on the main link line from:
#
#   "-lm -ltre -o crm114" to "-ltre -o crm114"
#
#  PowerPPC has no sqrtf function
# CFLAGS += -DNO_SQRTF
#
# --------------End of Mac OSX stuff -----------------------
#
#
#    End of user-configurable options... if you modify anything below
#    this line, you risk early insanity and blindness.
#
#
#   These are the files needed to build the CRM114 engine; they don't
#   include the side utilities
#
CFILES = crm_main.c crm_compiler.c crm_errorhandlers.c \
	crm_math_exec.c crm_var_hash_table.c crm_expandvar.c \
	crm_stmt_parser.c crm_vector_tokenize.c \
	crm_expr_alter.c crm_expr_match.c crm_css_maintenance.c \
	crm_markovian.c crm_osb_bayes.c crm_osb_hyperspace.c \
	crm_correlate.c crm_osb_winnow.c crm_winnow_maintenance.c \
	crm_osbf_bayes.c crm_osbf_maintenance.c crm_bit_entropy.c \
	crm_neural_net.c crm_expr_clump.c \
	crm_expr_window.c crm_expr_isolate.c crm_expr_file_io.c \
	crm_expr_syscall.c crm_expr_classify.c crm_expr_translate.c \
	crm_exec_engine.c crm_debugger.c crm_str_funcs.c \
	crm_preprocessor.c crmregex_tre.c \
	crm_stats.c crm_expr_sks.c\
	crm_expr_svm.c crm_fast_substring_compression.c

HFILES = Makefile crm114_sysincludes.h crm114_structs.h crm114_config.h \
	crm114.h crm114_osbf.h

OFILES = crm_main.o crm_compiler.o crm_errorhandlers.o \
	crm_math_exec.o crm_var_hash_table.o crm_expandvar.o \
	crm_stmt_parser.o crm_vector_tokenize.o \
	crm_expr_alter.o crm_expr_match.o crm_css_maintenance.o \
	crm_markovian.o crm_osb_bayes.o crm_osb_hyperspace.o \
	crm_correlate.o crm_osb_winnow.o crm_winnow_maintenance.o \
	crm_osbf_bayes.o crm_osbf_maintenance.o crm_bit_entropy.o \
	crm_neural_net.o crm_expr_clump.o \
	crm_expr_window.o crm_expr_isolate.o crm_expr_file_io.o \
	crm_expr_syscall.o crm_expr_classify.o crm_expr_translate.o \
	crm_exec_engine.o crm_debugger.o crm_str_funcs.o \
	crm_preprocessor.o crmregex_tre.c \
	crm_expr_sks.o crm_stats.o crm_expr_svm.o \
	crm_fast_substring_compression.o

UTILFILES = osbf-util.c cssutil.c  cssdiff.c cssmerge.c crm_util_errorhandlers.c

CRMFILES = mailfilter.crm mailfilter.cf \
	mailreaver.crm mailtrainer.crm \
	maillib.crm shuffle.crm \
	rewriteutil.crm \
	matchtest.crm windowtest.crm overalterisolatedtest.crm exectest.crm \
	learntest.crm classifytest.crm \
	escapetest.crm argtest.crm beeptest.crm skudtest.crm aliustest.crm \
	nestaliustest.crm eval_infiniteloop.crm \
	traptest.crm fataltraptest.crm uncaughttraptest.crm \
	inserttest_a.crm inserttest_b.crm inserttest_c.crm \
	backwardstest.crm approxtest.crm \
	mathalgtest.crm mathrpntest.crm \
	indirecttest.crm translate_tr.crm zz_translate_test.crm \
	rewritetest.crm test_rewrites.mfp \
	randomiotest.crm isolate_reclaim_test.crm \
	match_isolate_test.crm match_isolate_reclaim.crm \
	call_return_test.crm defaulttest.crm alternating_example_neural.crm \
	shroud.crm quine.crm \
	bracktest.crm unionintersecttest.crm \
	statustest.crm windowtest_fromvar.crm paolo_overvars.crm \
	paolo_ov2.crm paolo_ov3.crm paolo_ov4.crm paolo_ov5.crm \
	pad.crm calc.crm \
	gatlingsort.crm tenfold_validate.crm\
	test_svm.crm \
	classifymail.crm

TEXTFILES = COLOPHON.txt pad.dat \
	QUICKREF.txt INTRO.txt KNOWNBUGS.txt FAQ.txt THINGS_TO_DO.txt \
	CLASSIFY_DETAILS.txt README CRM114_Mailfilter_HOWTO.txt \
	Alice_In_Wonderland_Chap_1_And_2.txt Macbeth_Act_IV.txt \
	Hound_of_the_Baskervilles_first_500_lines.txt \
	The_Wind_in_the_Willows_Chap_1.txt \
	reto_procmailrc.recipe \
	priolist.mfp blacklist.mfp whitelist.mfp rewrites.mfp \
	priolist.mfp.example blacklist.mfp.example whitelist.mfp.example \
	crm114-mode.el \
	crm114.spec \
	inoc_passwd.txt \
	GPL_License.txt \
	megatest.sh megatest_knowngood.log


#
#

all: crm114 cssutil cssdiff cssmerge osbf-util
	#
	#    Done.
	#
	#    ***  Type "make help" to see what else you can make.
	#

help: FORCE
	#
	#    You can make the following things:
	#
	#    make   -or-   make all   - builds the binaries.  This uses the
	#                               
	#    make crm114              - build CRM binary. This uses the
	#                               TRE regex library
	#    make install             - builds and installs the binaries.
	#                               You must be root to do this.
	#    make uninstall           - uninstalls the binaries.  You must
	#                               be root to do this.
	#    make megatest            - runs the full test suite ( takes
	#                               about ~1 minute, TRE version _ONLY_! )
	#    make clean               - deletes all .o and executables.
	#                               Don't do this on a binary kit!
	#    make cssfiles            - builds a set of .css files from data
	#                               in ./good.dir/* and ./spam.dir/*
	#    make distribtion         - builds the .gzballs for distribution
        #                               of with your mods built in.

crm114: $(OFILES)
	$(CC) $(LDFLAGS) $(LIBS) $(OFILES) \
	  -ltre -lm\
	  -o crm114
	#
	#    Done.  Type "make help" to see what else you can make.
	#

*.o: $(HFILES)
.c.o:
	$(CC)  $(CFLAGS) -c $*.c


cssutil: cssutil.o crm_css_maintenance.o crm_util_errorhandlers.o crm_str_funcs.o $(HFILES)
	$(CC)  $(CFLAGS) $(LDFLAGS) cssutil.o \
		crm_css_maintenance.o \
		crm_util_errorhandlers.o \
		crm_str_funcs.o -lm -ltre -o cssutil

osbf-util: osbf-util.o crm_osbf_maintenance.o crm_util_errorhandlers.o crm_str_funcs.o $(HFILES)
	$(CC)  $(CFLAGS) $(LDFLAGS) osbf-util.o \
		crm_str_funcs.o \
		crm_util_errorhandlers.o \
		crm_osbf_maintenance.o -lm -ltre -o osbf-util

cssdiff: cssdiff.o crm_util_errorhandlers.o crm_str_funcs.o $(HFILES)
	$(CC)  $(CFLAGS) $(LDFLAGS) \
		crm_util_errorhandlers.o \
		crm_str_funcs.o -ltre cssdiff.o -o cssdiff

cssmerge: cssmerge.o crm_util_errorhandlers.o crm_str_funcs.o $(HFILES)
	$(CC)  $(CFLAGS) $(LDFLAGS) \
		cssmerge.o crm_str_funcs.o \
		crm_util_errorhandlers.o \
		-ltre -o cssmerge

clean:
	-rm -f crm114
	-rm -f cssutil
	-rm -f osbf-util
	-rm -f cssdiff
	-rm -f cssmerge
	-rm -f crm114
	-rm -f crm114_tre
	-rm -f *.o

install: FORCE
	$(MAKE) install_engine install_utils
	#
	#    Done.  Type "make help" to see what else you can make.
	#

install_utils:
	#
	#    Installing Utilities
	#
	$(MAKE) cssmerge cssutil cssdiff osbf-util
	install $(INSTALLFLAGS) cssdiff $(BINDIR)/cssdiff$(VER_SUFFIX)
	install $(INSTALLFLAGS) cssmerge $(BINDIR)/cssmerge$(VER_SUFFIX)
	install $(INSTALLFLAGS) cssutil $(BINDIR)/cssutil$(VER_SUFFIX)
	install $(INSTALLFLAGS) osbf-util $(BINDIR)/osbf-util$(VER_SUFFIX)

## crm114 20090807

=== Makefile ===
--- 
+++ 
@@ -21,14 +21,15 @@
 #
 #      The following forces the compiler to be GCC.  If you have trouble
 #      with your default compiler, and you want to force GCC, uncomment it.
-# CC=gcc
+CC=gcc
 #
 #     What version is this software (PLEASE don't change this just
 #     to mess with my brain. - wsy)
 #
 CRM114_ARCHIVE = /homes/crm114/archive
-VERSION=200904023-BlameSteveJobs
-PREV_VERSION=20090120-BlameSteveJobs
+VERSION=20090807-BlameThorstenAndJenny
+PREV_VERSION=20090806-LastOldSVM
+#PREV_VERSION=20090120-BlameSteveJobs
 #PREV_VERSION=20081111-BlameBarack
 #PREV_VERSION=20081023-BlameMaxwell
 #PREV_VERSION=20080923-BlameVT
@@ -97,12 +98,12 @@
 #  really picayune stuff.
 #
 #  Our default is with debugging, full optimization, and lots of warnings:
-CFLAGS += -g -O3 -Wall
+CFLAGS += -O3 -Wall
 #     turn this one on for no optimization, but debugging
 #CFLAGS += -g -O0 -Wall
 #
 #     Turn this one on for time profiling.
-#CFLAGS += -pg
+#CFLAGS += -pg -O0
 #     turn this one on for really picayune debugging:
 # CFLAGS += -Wextra
 #
@@ -194,10 +195,12 @@
 	crm_exec_engine.c crm_debugger.c crm_str_funcs.c \
 	crm_preprocessor.c crmregex_tre.c \
 	crm_stats.c crm_expr_sks.c\
-	crm_expr_svm.c crm_fast_substring_compression.c
+	crm_svm_matrix_util.c crm_svm_quad_prog.c crm_svm_matrix.c\
+	crm_svm_lib_fncts.c crm_svm.c crm_fast_substring_compression.c
 
 HFILES = Makefile crm114_sysincludes.h crm114_structs.h crm114_config.h \
-	crm114.h crm114_osbf.h
+	crm114.h crm114_osbf.h crm_svm_matrix_util.h crm_svm_quad_prog.h\
+	crm_svm_matrix.h crm_svm_lib_fncts.h crm_svm.h
 
 OFILES = crm_main.o crm_compiler.o crm_errorhandlers.o \
 	crm_math_exec.o crm_var_hash_table.o crm_expandvar.o \
@@ -211,7 +214,9 @@
 	crm_expr_syscall.o crm_expr_classify.o crm_expr_translate.o \
 	crm_exec_engine.o crm_debugger.o crm_str_funcs.o \
 	crm_preprocessor.o crmregex_tre.c \
-	crm_expr_sks.o crm_stats.o crm_expr_svm.o \
+	crm_expr_sks.o crm_stats.o \
+	crm_svm_matrix_util.o crm_svm_quad_prog.o crm_svm_matrix.o\
+	crm_svm_lib_fncts.o crm_svm.o \
 	crm_fast_substring_compression.o
 
 UTILFILES = osbf-util.c cssutil.c  cssdiff.c cssmerge.c crm_util_errorhandlers.c
@@ -233,7 +238,7 @@
 	randomiotest.crm isolate_reclaim_test.crm \
 	match_isolate_test.crm match_isolate_reclaim.crm \
 	call_return_test.crm defaulttest.crm alternating_example_neural.crm \
-	shroud.crm quine.crm \
+	shroud.crm quine.crm alternating_example_svm.crm \
 	bracktest.crm unionintersecttest.crm \
 	statustest.crm windowtest_fromvar.crm paolo_overvars.crm \
 	paolo_ov2.crm paolo_ov3.crm paolo_ov4.crm paolo_ov5.crm \
@@ -291,7 +296,7 @@
 
 crm114: $(OFILES)
 	$(CC) $(LDFLAGS) $(LIBS) $(OFILES) \
-	  -ltre -lm\
+	  -ltre -lm \
 	  -o crm114
 	#
 	#    Done.  Type "make help" to see what else you can make.
@@ -300,7 +305,6 @@
 *.o: $(HFILES)
 .c.o:
 	$(CC)  $(CFLAGS) -c $*.c
-
 
 cssutil: cssutil.o crm_css_maintenance.o crm_util_errorhandlers.o crm_str_funcs.o $(HFILES)
 	$(CC)  $(CFLAGS) $(LDFLAGS) cssutil.o \
@@ -346,7 +350,3 @@
 	#    Installing Utilities
 	#
 	$(MAKE) cssmerge cssutil cssdiff osbf-util
-	install $(INSTALLFLAGS) cssdiff $(BINDIR)/cssdiff$(VER_SUFFIX)
-	install $(INSTALLFLAGS) cssmerge $(BINDIR)/cssmerge$(VER_SUFFIX)
-	install $(INSTALLFLAGS) cssutil $(BINDIR)/cssutil$(VER_SUFFIX)
-	install $(INSTALLFLAGS) osbf-util $(BINDIR)/osbf-util$(VER_SUFFIX)

=== debian/changelog ===
crm114 (20090807-6) unstable; urgency=low

  * Spanish debconf translation updated; closes: #600508.

 -- Milan Zamazal <pdm@debian.org>  Wed, 27 Oct 2010 21:37:19 +0200

crm114 (20090807-5) unstable; urgency=low

  * Change default good_threshold value from 10 to 5; closes: #554172.
  * German and Vietnamese debconf translation updates; closes: #570769,
    #572772.

 -- Milan Zamazal <pdm@debian.org>  Mon, 08 Mar 2010 20:07:46 +0100

crm114 (20090807-4) unstable; urgency=low

  * debian/rules: Call debconf-updatepo in `clean'; closes: #569221.
  * Russian, French, Portuguese, Czech, Swedish, Japanese, Italian debconf
    translation updates; closes: #568891, #569064, #569071, #569716,
    #569895, #570614.

 -- Milan Zamazal <pdm@debian.org>  Sat, 20 Feb 2010 11:41:23 +0100

crm114 (20090807-3) unstable; urgency=low

  * New debconf option `forceupgrade'; closes: #562946.

 -- Milan Zamazal <pdm@debian.org>  Sun, 07 Feb 2010 15:59:10 +0100

crm114 (20090807-2) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format.
  * Missing NEWS entry about .css incompatibility added.

 -- Milan Zamazal <pdm@debian.org>  Sat, 23 Jan 2010 16:18:37 +0100

crm114 (20090807-1) unstable; urgency=low

  * New upstream version; closes: #548060.
  * Debconf templates and debian/control reviewed by the
    debian-l10n-english team as part of the Smith review project. Thanks
    to Christian Perrier and other contributors. Closes: #529720, #548095.
  * [Debconf translation updates]
  * Swedish (Martin Ågren); closes: #548789
  * Portuguese (Américo Monteiro); closes: #548829
  * Vietnamese (Clytie Siddall); closes: #548992
  * German (Thomas Mueller); closes: #549242
  * Italian (Luca Monducci); closes: #549582
  * Finnish (Esko Arajärvi); closes: #549857
  * Spanish (Francisco Javier Cuadrado); closes: #550175
  * Russian (Yuri Kozlov); closes: #550177
  * French (Christian Perrier); closes: #550812
  * Japanese (Hideki Yamane (Debian-JP)); closes: #551020
  * Czech (Milan Zamazal).

 -- Milan Zamazal <pdm@debian.org>  Tue, 20 Oct 2009 09:52:37 +0200

crm114 (20090423-2) unstable; urgency=low

  * Print warning about .css files incompatibility on upgrades from old
    versions.
  * Standards 3.8.3 (no real change).
  * README.source addded.

 -- Milan Zamazal <pdm@debian.org>  Sun, 30 Aug 2009 08:38:28 +0200

crm114 (20090423-1) unstable; urgency=low

  * New upstream version; closes: #439514.
  * Fix typo in COLOPHON.txt; closes: #471554.
  * Document the need of mailtrainer.crm presence for mailreaver.crm
    operation; closes: #517154.
  * Homepage field added.
  * Support `parallel' in DEB_BUILD_OPTIONS.
  * Standards 3.8.1.
  * debian/copyright updated.
  * Updated to debhelper 7.

 -- Milan Zamazal <pdm@debian.org>  Mon, 11 May 2009 09:11:00 +0200

crm114 (20080330-2) unstable; urgency=low

  * Make scripts in /usr/share/crm114/ executable again; closes: #473747.

 -- Milan Zamazal <pdm@debian.org>  Thu, 03 Apr 2008 10:37:20 +0200

crm114 (20080330-1) unstable; urgency=low

  * New upstream snapshot.
  * Use dpatch to manage Debian patches.
  * Upstream fix of regexp cache handling added; closes: #470492.
  * Standards-Version increased to 3.7.3 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Mon, 31 Mar 2008 11:16:35 +0200

crm114 (20080315-1) experimental; urgency=low

  * New upstream development snapshot.

 -- Milan Zamazal <pdm@debian.org>  Sat, 15 Mar 2008 09:08:06 +0100

crm114 (20070810-3) unstable; urgency=low

  * Add shuffle.crm into /usr/share/crm114/; closes: #460278.

 -- Milan Zamazal <pdm@debian.org>  Thu, 17 Jan 2008 23:40:31 +0100

crm114 (20070810-2) unstable; urgency=low

  * Broken .css files compatibility on 32-bit architectures, introduced in
    20070810-1, fixed.

 -- Milan Zamazal <pdm@debian.org>  Wed, 29 Aug 2007 10:31:55 +0200

crm114 (20070810-1) unstable; urgency=low

  * New upstream version; closes: #433112.
  * Tried to make some variable types related to cssutil more specific to
    prevent repeating problems on 64-bit architectures.

 -- Milan Zamazal <pdm@debian.org>  Wed, 22 Aug 2007 07:51:49 +0200

crm114 (20070320-1) unstable; urgency=low

  * New upstream version; closes: #416446.
  * Honor DEB_BUILD_OPTIONS.
  * Make sure crm114-mode.el gets installed.

 -- Milan Zamazal <pdm@debian.org>  Sun, 24 Jun 2007 12:35:53 +0200

crm114 (20061103-1) experimental; urgency=low

  * New upstream version; closes: #406089.
  * Upload to experimental because etch is in freeze.
  * Don't add Message-Id header if there's not any, information about
    broken threading added to README.Debian; this attempts to solve bug
    #406207.

 -- Milan Zamazal <pdm@debian.org>  Sun, 28 Jan 2007 10:11:06 +0100

crm114 (20060704a-4) unstable; urgency=low

  * Use full path when loading maillib.crm in mailreaver.crm;
    closes: #398078.

 -- Milan Zamazal <pdm@debian.org>  Sun, 12 Nov 2006 10:08:53 +0100

crm114 (20060704a-3) unstable; urgency=low

  * Fixes of typos in mailfilter.cf, thanks to Martin Steigerwald
    <Martin@Lichtvoll.de>; closes: #394476.

 -- Milan Zamazal <pdm@debian.org>  Sun, 22 Oct 2006 09:05:52 +0200

crm114 (20060704a-2) unstable; urgency=low

  * Install all mail*.crm scripts into /usr/share/crm114/.
  * Add upgrade warnings to NEWS.Debian and README.Debian;
    closes: #377978, #378084, #378135.

 -- Milan Zamazal <pdm@debian.org>  Fri, 14 Jul 2006 10:23:07 +0200

crm114 (20060704a-1) unstable; urgency=low

  * New upstream version.
  * Standards 3.7.2 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Mon, 10 Jul 2006 23:19:34 +0200

crm114 (20060118-1) unstable; urgency=low

  * New upstream version; closes: #339393.

 -- Milan Zamazal <pdm@debian.org>  Tue,  7 Feb 2006 09:52:03 +0100

crm114 (20050721-2) unstable; urgency=low

  * Missing :classify_status: declaration added in mailfilter.crm;
    closes: #318720.

 -- Milan Zamazal <pdm@debian.org>  Tue,  9 Aug 2005 17:36:41 +0200

crm114 (20050721-1) unstable; urgency=low



=== debian/control ===
Source: crm114
Section: mail
Priority: optional
Maintainer: Milan Zamazal <pdm@debian.org>
Build-Depends: debhelper (>= 7), libtre-dev (>= 0.6.8), po-debconf
Standards-Version: 3.8.3
Homepage: http://crm114.sourceforge.net

Package: crm114
Architecture: any
Pre-Depends: debconf
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: metamail | mew-bin
Description: versatile classifier for e-mail and other data
 CRM114, the Controllable Regex Mutilator, is a system to examine incoming
 e-mail, system log streams, data files, or other data streams, and to sort,
 filter, or alter the incoming files or data streams however the user
 desires. Criteria for categorization of data can be by satisfaction of
 regular expressions, by sparse binary polynomial matching with a Bayesian
 Chain Rule evaluator, or by other means.
 .
 CRM114 is not just another drop-in spam-filtering system; its Sparse
 Binary Polynomial Hashing methods give it the power to develop highly
 accurate Bayesian filters on very little training.
 .
 CRM114 is compatible with SpamAssassin or other spam-flagging software; it
 can also be pipelined in front of or behind procmail. CRM114 is also useful
 as a syslog or firewall log filter, to flag up important events but ignore
 the ones that aren't meaningful.
 .
 For mail filtering, installing metamail or mew-bin packages is
 recommended in order to have tools to decode MIME attachments.

=== debian/rules ===
#!/usr/bin/make -f

.NOTPARALLEL:

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

package=crm114

CFLAGS := -DVERSION='\"\$$(VERSION)\"' -Wall -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

build: build-stamp
build-stamp:
	dh_testdir
	$(MAKE) $(MAKEFLAGS) CFLAGS="$(CFLAGS)"
	touch build-stamp

clean: 
	dh_testdir
	dh_testroot
	rm -f build-stamp
	$(MAKE) clean
	dh_clean
	debconf-updatepo

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) install prefix=`pwd`/debian/$(package)/usr
	install shuffle.crm `pwd`/debian/$(package)/usr/share/crm114/
	dh_installdebconf

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_install
	dh_installdocs
	rm `pwd`/debian/crm114/usr/share/doc/$(package)/GPL_License.txt
	mv `pwd`/debian/crm114/usr/share/doc/$(package)/*test* \
	   `pwd`/debian/crm114/usr/share/doc/$(package)/examples/tests/
	set -e; for ext in cf crm dat example mfp recipe; do \
		mv `pwd`/debian/crm114/usr/share/doc/$(package)/*.$$ext \
	           `pwd`/debian/crm114/usr/share/doc/$(package)/examples/; \
	done
	dh_installexamples
	set -e; for file in `pwd`/debian/crm114/usr/share/doc/$(package)/examples/* \
	                    `pwd`/debian/crm114/usr/share/doc/$(package)/examples/tests/*; do \
		if [ -f $$file ] && [ "`head -c 2 $$file`" != '#!' ]; then \
			chmod a-x $$file; \
		fi; \
	done
	chmod a-x `pwd`/debian/crm114/usr/share/crm114/mailfilter.cf
	chmod a+x `pwd`/debian/crm114/usr/share/crm114/*.crm
	chmod a-x `pwd`/debian/crm114/usr/share/crm114/maillib.crm
	chmod a-x `pwd`/debian/crm114/usr/share/emacs/site-lisp/*
	dh_installman debian/*.1
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## crm114 20100106

=== Makefile ===
--- 
+++ 
@@ -27,8 +27,11 @@
 #     to mess with my brain. - wsy)
 #
 CRM114_ARCHIVE = /homes/crm114/archive
-VERSION=20090807-BlameThorstenAndJenny
-PREV_VERSION=20090806-LastOldSVM
+VERSION=20100106-BlameMichelson
+PREV_VERSION=20091209-BlameMichelson
+#PREV_VERSION=20090914-BlameThorstenAndJenny
+#PREV_VERSION=20090806-LastOldSVM
+#PREV_VERSION=20090423-BlameSteveJobs
 #PREV_VERSION=20090120-BlameSteveJobs
 #PREV_VERSION=20081111-BlameBarack
 #PREV_VERSION=20081023-BlameMaxwell
@@ -97,8 +100,11 @@
 #  and warn on all warnable things "-Wall".  Someday add -Wextra for
 #  really picayune stuff.
 #
-#  Our default is with debugging, full optimization, and lots of warnings:
-CFLAGS += -O3 -Wall
+#  Our default is with full optimization, lots of warnings, and forcing
+#  certain functions to be inline (I added that to force gcc to inline functions
+#  under high optimization but not under low so that debugging is possible - 
+#  that's why DO_INLINES is defined at O3 but not O0 - JB):
+CFLAGS += -O3 -Wall -DDO_INLINES
 #     turn this one on for no optimization, but debugging
 #CFLAGS += -g -O0 -Wall
 #
@@ -111,6 +117,8 @@
 #   Comment this out if you want dynamic linking
 #
 #    BSD users - do NOT use -static-libgcc!!!
+#    Also note that this keeps valgrind from running correctly so comment
+#    it out for debugging.
 LDFLAGS += -static -static-libgcc
 #    use this one if you want program profiling.
 #LDFLAGS += -static -static-libgcc -pg
@@ -196,11 +204,13 @@
 	crm_preprocessor.c crmregex_tre.c \
 	crm_stats.c crm_expr_sks.c\
 	crm_svm_matrix_util.c crm_svm_quad_prog.c crm_svm_matrix.c\
-	crm_svm_lib_fncts.c crm_svm.c crm_fast_substring_compression.c
+	crm_svm_lib_fncts.c crm_svm.c crm_pca_lib_fncts.c crm_pca.c\
+	crm_fast_substring_compression.c
 
 HFILES = Makefile crm114_sysincludes.h crm114_structs.h crm114_config.h \
 	crm114.h crm114_osbf.h crm_svm_matrix_util.h crm_svm_quad_prog.h\
-	crm_svm_matrix.h crm_svm_lib_fncts.h crm_svm.h
+	crm_svm_matrix.h crm_svm_lib_fncts.h crm_svm.h crm_pca_lib_fncts.h\
+	crm_pca.h
 
 OFILES = crm_main.o crm_compiler.o crm_errorhandlers.o \
 	crm_math_exec.o crm_var_hash_table.o crm_expandvar.o \
@@ -216,7 +226,7 @@
 	crm_preprocessor.o crmregex_tre.c \
 	crm_expr_sks.o crm_stats.o \
 	crm_svm_matrix_util.o crm_svm_quad_prog.o crm_svm_matrix.o\
-	crm_svm_lib_fncts.o crm_svm.o \
+	crm_svm_lib_fncts.o crm_svm.o crm_pca_lib_fncts.o crm_pca.o\
 	crm_fast_substring_compression.o
 
 UTILFILES = osbf-util.c cssutil.c  cssdiff.c cssmerge.c crm_util_errorhandlers.c
@@ -239,6 +249,7 @@
 	match_isolate_test.crm match_isolate_reclaim.crm \
 	call_return_test.crm defaulttest.crm alternating_example_neural.crm \
 	shroud.crm quine.crm alternating_example_svm.crm \
+	alternating_example_pca.crm \
 	bracktest.crm unionintersecttest.crm \
 	statustest.crm windowtest_fromvar.crm paolo_overvars.crm \
 	paolo_ov2.crm paolo_ov3.crm paolo_ov4.crm paolo_ov5.crm \
@@ -321,32 +332,3 @@
 cssdiff: cssdiff.o crm_util_errorhandlers.o crm_str_funcs.o $(HFILES)
 	$(CC)  $(CFLAGS) $(LDFLAGS) \
 		crm_util_errorhandlers.o \
-		crm_str_funcs.o -ltre cssdiff.o -o cssdiff
-
-cssmerge: cssmerge.o crm_util_errorhandlers.o crm_str_funcs.o $(HFILES)
-	$(CC)  $(CFLAGS) $(LDFLAGS) \
-		cssmerge.o crm_str_funcs.o \
-		crm_util_errorhandlers.o \
-		-ltre -o cssmerge
-
-clean:
-	-rm -f crm114
-	-rm -f cssutil
-	-rm -f osbf-util
-	-rm -f cssdiff
-	-rm -f cssmerge
-	-rm -f crm114
-	-rm -f crm114_tre
-	-rm -f *.o
-
-install: FORCE
-	$(MAKE) install_engine install_utils
-	#
-	#    Done.  Type "make help" to see what else you can make.
-	#
-
-install_utils:
-	#
-	#    Installing Utilities
-	#
-	$(MAKE) cssmerge cssutil cssdiff osbf-util

=== debian/changelog ===
crm114 (20100106-9) unstable; urgency=medium

  * Use dh_auto_build to compile the sources; thanks to
    Helmut Grohne <helmut@subdivi.de>; closes: #916275.
  * Standards 4.3.0 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Mon, 24 Dec 2018 15:03:33 +0100

crm114 (20100106-8) unstable; urgency=medium

  * Standards 4.1.5 (no real change).
  * Debhelper compatibility version increased to 10.

 -- Milan Zamazal <pdm@debian.org>  Wed, 11 Jul 2018 15:07:19 +0200

crm114 (20100106-7) unstable; urgency=low

  * Brazilian translation added (Adriano Rafael Gomes); closes: #811539.
  * Standards 3.9.6 (no real change).
  * Use dpkg build flags.

 -- Milan Zamazal <pdm@debian.org>  Tue, 19 Jan 2016 20:03:47 +0100

crm114 (20100106-6) unstable; urgency=low

  * Fix FTBFS with clang; thanks to Arthur Marble <arthur@info9.net>;
    closes: #757266.

 -- Milan Zamazal <pdm@debian.org>  Sat, 09 Aug 2014 11:55:53 +0200

crm114 (20100106-5) unstable; urgency=low

  * Function declaration conflicts fixed; closes: #748029.
  * Standards 3.9.5 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Sat, 24 May 2014 20:50:32 +0200

crm114 (20100106-4) experimental; urgency=low

  * Fix of DEFAULT_PASSWORD typo in mailfilter.cf (thanks to
    Trent W. Buck); closes: #693946.
  * Upload to experimental because wheezy is frozen.

 -- Milan Zamazal <pdm@debian.org>  Thu, 22 Nov 2012 21:33:47 +0100

crm114 (20100106-3) unstable; urgency=low

  * Dutch debconf translation added (Jeroen Schot); closes: #675149.

 -- Milan Zamazal <pdm@debian.org>  Mon, 04 Jun 2012 20:55:05 +0200

crm114 (20100106-2) unstable; urgency=low

  * Man page formatting a bit improved; closes: #664733.
  * Standards 3.9.3 (no real change).
  * build-arch and build-indep targets added to debian/rules.

 -- Milan Zamazal <pdm@debian.org>  Sat, 31 Mar 2012 18:58:10 +0200

crm114 (20100106-1) unstable; urgency=low

  * New upstream version.
  * Danish translation added (Joe Dalton); closes: #630375.
  * Standards 3.9.2 (no real change).

 -- Milan Zamazal <pdm@debian.org>  Sun, 19 Jun 2011 19:15:25 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: mail
 Priority: optional
 Maintainer: Milan Zamazal <pdm@debian.org>
-Build-Depends: debhelper (>= 7), libtre-dev (>= 0.6.8), po-debconf
-Standards-Version: 3.8.3
+Build-Depends: debhelper (>= 10), libtre-dev (>= 0.6.8), po-debconf
+Standards-Version: 4.3.0
 Homepage: http://crm114.sourceforge.net
 
 Package: crm114

=== debian/rules ===
--- 
+++ 
@@ -7,24 +7,20 @@
 
 package=crm114
 
-CFLAGS := -DVERSION='\"\$$(VERSION)\"' -Wall -g
-ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-	CFLAGS += -O0
-else
-	CFLAGS += -O2
-endif
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+DPKG_EXPORT_BUILDFLAGS = 1
+include /usr/share/dpkg/buildflags.mk
+CFLAGS += -DVERSION='\"\$$(VERSION)\"'
 ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
 	INSTALL_PROGRAM += -s
 endif
-ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-    MAKEFLAGS += -j$(NUMJOBS)
-endif
 
-build: build-stamp
+build: build-arch build-indep
+build-arch: build-stamp
+build-indep: build-stamp
 build-stamp:
 	dh_testdir
-	$(MAKE) $(MAKEFLAGS) CFLAGS="$(CFLAGS)"
+	dh_auto_build --parallel -- CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"
 	touch build-stamp
 
 clean:
